<template>
  <JDraggable
    v-slot="dragProps"
    initial-top="calc(97% - 250px)"
    initial-left="calc(97% - 350px)"
  >
    <div
      v-bg-image="{ url: chatAvatar, cdn: true }"
      class="connection-offer-wrapper"
    >
      <div class="connection-offer">
        <ConnectionCallHeader
          v-bind="dragProps"
          :dialog-id="dialogId"
        />
        <div class="body">
          <ConversationRoomAvatar
            v-if="typeof chatAvatar === 'object'"
            :chat="chatAvatar"
          />
          <UserAvatar
            v-else
            :avatar="chatAvatar"
            avatar-size="xl-3"
            hide-status
          />
          <JText
            color="subtitle"
            type="text-2"
            weight="normal"
            class="name"
          >
            {{ $t('calls_you') }}: <br/>
            {{ chatName }}
          </JText>
        </div>
        <div class="footer">
          <JButton
            type="flat"
            class="offer-action"
            @click="acceptConnectionOffer(true)"
          >
            <JIcon
              size="20px"
              icon="camera"
            />
          </JButton>
          <JButton
            type="flat"
            class="offer-action"
            @click="acceptConnectionOffer(false)"
          >
            <JIcon
              size="20px"
              icon="microphone"
            />
          </JButton>
          <JButton
            type="flat"
            color="red"
            class="offer-action"
            @click="onCancelConnection"
          >
            <JIcon
              size="20px"
              icon="hangUp"
            />
          </JButton>
        </div>
      </div>
    </div>
  </JDraggable>
</template>

<script setup lang="ts">
import {
  computed, inject, PropType, watch,
} from 'vue';
import {
  JButton, JDraggable, JIcon, JText,
} from '@new-jira-clone/ui/src/components';
import { DialogPlugin } from '@new-jira-clone/ui/src/plugins/dialog';
import { useSocketStore } from '@new-jira-clone/libs/src/store';
import { UserAvatar } from '@/entities/User';
import {
  ChatTypes, IChat, IGroupChat, IUser,
} from '@/shared';
import ConnectionCallHeader from './ConnectionCallHeader.vue';
import ConnectionAnswer from './ConnectionAnswer.vue';
import useCreateCallAnswer from '../model/useCreateCallAnswer';
import { usePeerConnection } from '../model/usePeerConnection';
import { useMediaStreamStore } from '../model/useMediaStreamStore';

const props = defineProps({
  dialogId: {
    type: Number,
    default: null,
  },
  connectionTarget: {
    type: Object as PropType<IChat | IUser>,
    required: true,
  },
});

const $dialog = inject('$dialog') as DialogPlugin;

const { getConnectionState } = useMediaStreamStore();
const { socket } = useSocketStore();
const { cancelConnection } = usePeerConnection();

const chatAvatar = computed(() => {
  if ('interlocutor' in props.connectionTarget) {
    return props.connectionTarget.interlocutor.avatar;
  }

  if ('type' in props.connectionTarget && props.connectionTarget.type === ChatTypes.Group) {
    return props.connectionTarget as IGroupChat;
  }

  return props.connectionTarget.avatar;
});

const chatName = computed(() => {
  if ('interlocutor' in props.connectionTarget) {
    return props.connectionTarget.interlocutor.name;
  }

  return props.connectionTarget.name;
});

const connectionTargetId = computed(() => {
  if ('interlocutor' in props.connectionTarget) {
    return props.connectionTarget.getId();
  }

  return props.connectionTarget.id;
});

const connectionState = getConnectionState(connectionTargetId.value);

const acceptConnectionOffer = async (video: boolean) => {
  const { createCallAnswer } = useCreateCallAnswer();
  const { getRtcDescription } = useMediaStreamStore();

  const rtcDescription = getRtcDescription(connectionTargetId.value);

  if (rtcDescription.value === null) return;

  try {
    await createCallAnswer(connectionTargetId.value, rtcDescription.value, video);
  } catch (error) {
    await createCallAnswer(connectionTargetId.value, rtcDescription.value, false);
  } finally {
    $dialog.close(props.dialogId);

    $dialog.show(ConnectionAnswer, {
      contentProps: {
        connectionTarget: props.connectionTarget,
      },
    });
  }
};

const onCancelConnection = () => {
  socket.value?.emit('stopCall', { chatId: connectionTargetId.value });
  cancelConnection(connectionTargetId.value);
  $dialog.close(props.dialogId);
};

watch(
  socket,
  (newSocket) => {
    newSocket?.on('stopCall', () => {
      $dialog.close(props.dialogId);
    });
  },
  {
    immediate: true,
  },
);

watch(
  connectionState,
  (newValue) => {
    if (newValue !== 'ringing') {
      $dialog.close(props.dialogId);
    }
  },
  { immediate: true },
);
</script>

<style scoped lang="scss">
.connection-offer-wrapper {
  display: flex;
  width: 350px;
  height: 250px;
  overflow: hidden;
  border-radius: 8px;
  background-repeat: no-repeat;
  background-position: center;
  background-size: cover;
}

.connection-offer {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  padding-right: 16px;
  padding-bottom: 16px;
  padding-left: 16px;
  width: 100%;
  color: #fff;
  backdrop-filter: blur(10px);
  background: linear-gradient(0deg, rgba(0, 0, 0, 0) 0%, rgba(0, 0, 0, 0.7) 100%),
    linear-gradient(180deg, rgba(0, 0, 0, 0) 0%, rgba(0, 0, 0, 0.7) 100%);
}

.body {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  margin-bottom: 15px;
  text-align: center;
}

.footer {
  display: flex;
  column-gap: 10px;
}

.offer-action {
  width: 100%;
}
</style>
